=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: shim
 Section: admin
 Priority: optional
-Maintainer: Debian EFI team <debian-efi@lists.debian.org>
+Maintainer: Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>
 Uploaders: Steve Langasek <vorlon@debian.org>, Steve McIntyre <93sam@debian.org>
 Standards-Version: 4.6.2
 Build-Depends: debhelper-compat (= 12),
@@ -19,7 +19,7 @@
 Vcs-Git: https://salsa.debian.org/efi-team/shim.git
 
 Package: shim-unsigned
-Architecture: amd64 arm64 i386
+Architecture: amd64 arm64
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Conflicts: shim (<< 15+1533136590.3beb971-3~),
 Replaces: shim (<< 15+1533136590.3beb971-3~),
@@ -38,13 +38,6 @@
  This package contains template files for shim-helpers-amd64-signed.
  This is only needed for Secure Boot signing.
 
-Package: shim-helpers-i386-signed-template
-Architecture: i386
-Depends: ${misc:Depends},
-Description: boot loader to chain-load signed boot loaders (signing template)
- This package contains template files for shim-helpers-i386-signed.
- This is only needed for Secure Boot signing.
-
 Package: shim-helpers-arm64-signed-template
 Architecture: arm64
 Depends: ${misc:Depends},
